// Code generated by "enumer -type=LicenseType -json -text -yaml -sql"; DO NOT EDIT.

//
package licenseTypes

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _LicenseTypeName = "NotSetBYByNcByNcNdByNcSaByNdBySaCCOPdSjPdWw"

var _LicenseTypeIndex = [...]uint8{0, 6, 8, 12, 18, 24, 28, 32, 35, 39, 43}

func (i LicenseType) String() string {
	if i < 0 || i >= LicenseType(len(_LicenseTypeIndex)-1) {
		return fmt.Sprintf("LicenseType(%d)", i)
	}
	return _LicenseTypeName[_LicenseTypeIndex[i]:_LicenseTypeIndex[i+1]]
}

var _LicenseTypeValues = []LicenseType{0, 1, 2, 3, 4, 5, 6, 7, 8, 9}

var _LicenseTypeNameToValueMap = map[string]LicenseType{
	_LicenseTypeName[0:6]:   0,
	_LicenseTypeName[6:8]:   1,
	_LicenseTypeName[8:12]:  2,
	_LicenseTypeName[12:18]: 3,
	_LicenseTypeName[18:24]: 4,
	_LicenseTypeName[24:28]: 5,
	_LicenseTypeName[28:32]: 6,
	_LicenseTypeName[32:35]: 7,
	_LicenseTypeName[35:39]: 8,
	_LicenseTypeName[39:43]: 9,
}

// LicenseTypeString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func LicenseTypeString(s string) (LicenseType, error) {
	if val, ok := _LicenseTypeNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to LicenseType values", s)
}

// LicenseTypeValues returns all values of the enum
func LicenseTypeValues() []LicenseType {
	return _LicenseTypeValues
}

// IsALicenseType returns "true" if the value is listed in the enum definition. "false" otherwise
func (i LicenseType) IsALicenseType() bool {
	for _, v := range _LicenseTypeValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for LicenseType
func (i LicenseType) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for LicenseType
func (i *LicenseType) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("LicenseType should be a string, got %s", data)
	}

	var err error
	*i, err = LicenseTypeString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for LicenseType
func (i LicenseType) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for LicenseType
func (i *LicenseType) UnmarshalText(text []byte) error {
	var err error
	*i, err = LicenseTypeString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for LicenseType
func (i LicenseType) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for LicenseType
func (i *LicenseType) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = LicenseTypeString(s)
	return err
}

func (i LicenseType) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *LicenseType) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := LicenseTypeString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
